<html>
<body>
<!-- #include file=ExcelADO.asp -->
<%
'Important include file above. you can insert the class code directly into the page, but for plug and play easy, leave it in an include file.
'See ExcelADO.htm for full instructions

' ExcelADO Database Demo
' Excel File access via ADO
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

	Dim ArrayIndex
	'Create an instance of the ExcelADO class
	Dim MyExcelFile
	Set MyExcelFile = New ExcelADO
	
	'If you wish to use the Excel driver or Text Driver, set it before opening the spreadsheet
	'MyExcelFile.Driver = MyExcelFile.DriverExcel

	'If you need to upload the data file to the server first, I prefer to use: "Upload Files without COM" v3.1 by Lewis Moten - http://upload.lewismoten.com
	'You also need a multipart form to select the file and pass it up with a field name of "File1"
	'!--#INCLUDE file="clsUpload.asp"--
	'Dim Upload, ImportFile
	'Set Upload = New clsUpload
	'ImportFile = Server.MapPath("/Files/Agents/" & Session("eCRM_User_No") & "/" & Upload.Fields("File1").FileName)
	'Upload("File1").SaveAs ImportFile
	'Set Upload = Nothing

	' Opens the dummy Access database and a RecordSet for easy data transfer
	Dim objSQLDB, objRS, strSQL
	Set objSQLDB = Server.CreateObject("ADODB.Connection")
	objSQLDB.Open  "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & Server.MapPath("db6.mdb") '**** Specify your DB name here
	Set objRS = Server.CreateObject("ADODB.RecordSet")

	'Open the Demo spreadsheet was error checking
	Response.Write("<font face='arial'><b>Opening Demo Spreadsheet:</b><br>")
	if not MyExcelFile.OpenSpreadsheet("ExcelDemo.xls") then 'ImportFile
		'The filenames are stored here during the open process
		Response.Write(MyExcelFile.AbsoluteFileName & " (" & MyExcelFile.VirtualFileName & ")<br>")
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		'The filenames are stored here during the open process
		Response.Write(MyExcelFile.AbsoluteFileName & " (" & MyExcelFile.VirtualFileName & ")<br>")
		Response.Write("Open<br>")
	end if
	'Flush now so we can see what's going on
	Response.Flush

	'Add additional SQL criteria. If omitted, then all records are returned in default order etc
	'MyExcelFile.SQLStatement = "WHERE KeyCode <> 'test' ORDER BY Salutation"

	'Open a worksheet for reading (faster then write mode) - with error checking
	Response.Write("<p><b>Opening worksheet:</b><br>")
	if not MyExcelFile.OpenWorksheet(MyExcelFile.Tables(0), MyExcelFile.forReading) then
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		Response.Write("Open<br>")

		'Display the Columns found when we opened the worksheet
		Response.Write("<p><b>Columns Names and Data Found:</b><br>")
		Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#ccffcc'>")
		For ArrayIndex = 0 to MyExcelFile.NumColumns -1  'Columns are referenced from 0 not 1
			Response.Write("<td>" & MyExcelFile.Columns(ArrayIndex) & "</td>")
		Next
		
		'Update each data row via the ReadRow method and a database recordset
		While MyExcelFile.ReadRow
			strSQL = "SELECT * FROM Contacts WHERE KeyCode = '" & MyExcelFile.ColumnData(0) & "' "
			objRS.Open strSQL, objSQLDB, 2, 2
			if objRS.EOF then
				'This is a new record
				'Do new record specific things here
				objRS.AddNew
			else
				'This is an existing record
				'Do update specific things here
			end if
			'Update the common fields. Assumes that the excel file is in the same layout as the database
			For ArrayIndex = 0 to MyExcelFile.NumColumns -1
				objRS(ArrayIndex) = MyExcelFile.ColumnData(ArrayIndex)
			Next
			'Or I could do it this way:
			'objRS("KeyCode") = MyExcelFile.ColumnData(0)
			'objRS("Salutation") = MyExcelFile.ColumnData(1)
			'objRS("FirstName") = MyExcelFile.ColumnData(2)
			'etc...
			objRS.Update
			objRS.Close
		wend	
		
		'Close that worksheet (Opening another worksheet automatically closes the previous sheet)
		MyExcelFile.CloseWorksheet
	end if
	
	'Close the Spreadsheet (destroying the object - setting it to nothing - will do this anyway)
	MyExcelFile.CloseSpreadsheet
	Response.Write("<p><b>Spreadsheet Closed</b><br>")
	
	'Destroy the object, releasing memory and closing resources if open
	Set MyExcelFile = nothing
	Set objRS = nothing
	Set objSQLDB = nothing
%>
</body>
</html>